#ifndef DSD_ENCODE_H
#define DSD_ENCODE_H

#include <stdint.h>

/*	Because any real implementation will involve more than one
 * encoder and decoder, i.e., at least one for the left,
 * and one for the right channel, it is best to formalize
 * the static variables as externed states.
 */

typedef struct {
    uint32_t dither_count;
    int32_t local_mod_lp;
} encoder_state;

int dsd_encode(int32_t pcm_sample, encoder_state *state);

extern encoder_state enc_state_1;
extern encoder_state enc_state_2;

#endif
